import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:itzam_socket_io/itzam_socket_io.dart';

void main() => runApp(MyApp());


class SOCKET_EVENTS{
  static const connected ="connected";
  static const disconnected ="disconnected";
  static const onNotification ="on-notification";
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String status = 'null';

  final SocketIO socketIO = SocketIO();

  @override
  void initState() {
    super.initState();
    initPlatformState();
  }

  // listeners for socketIo
  void onWS(String eventName, dynamic data) {

    // catch your event names listeners

    switch(eventName){
      case SOCKET_EVENTS.connected:
        print("connected to socketIO server");
        break;


      case SOCKET_EVENTS.onNotification:
        print("on-notification with data ${data.toString()}");
        break;


      case SOCKET_EVENTS.disconnected: // this is always called after the method  socketIO.disconnect()
        print("disconnected");
        break;
    }

  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {


    //define query params
    final query = Map<String, dynamic>();
    query['token'] = "eV6OEhGdFhBNm9NZHhiUjkWeGpu";

    socketIO.connect(host: "https://your-socket-io-server.com", query: query);
    //add listeners
    socketIO.onWS = this.onWS;
    // next add your listeners with your event names
    socketIO.on(SOCKET_EVENTS.connected);//
    socketIO.on(SOCKET_EVENTS.onNotification);//

    //the eventName "disconnected" is added by default, you don't need to do socketIO.on("disconnected");


    // emit
//    socketIO.emit(eventName: "myLocation", data: {
//      "latitude": -12.32033,
//      "longitude": 74.012131
//    });


    //   socketIO.disconnect(); // disconnect from socketIO server




  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Center(
          child: Text('Running on: $status\n'),
        ),
      ),
    );
  }
}
